<html>
<head>
<title>OGRE: OgreSkeletonSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSkeletonSerializer.h</h1><a href="OgreSkeletonSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __SkeletonSerializer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __SkeletonSerializer_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreSkeleton_8h.html">OgreSkeleton.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreSerializer_8h.html">OgreSerializer.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00051"></a><a class="code" href="classOgre_1_1SkeletonSerializer.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a>00054         <a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a>();
<a name="l00055"></a>00055         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SkeletonSerializer.html" title="Class for serialising skeleton data to/from an OGRE .skeleton file.">SkeletonSerializer</a>();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00066"></a>00066         <span class="keywordtype">void</span> exportSkeleton(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkeleton, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename,
<a name="l00067"></a>00067             <a class="code" href="classOgre_1_1Serializer.html#5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00068"></a>00068 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> importSkeleton(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pDest);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078         <span class="comment">// TODO: provide Cal3D importer?</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <span class="keyword">protected</span>:
<a name="l00081"></a>00081         <span class="comment">// Internal export methods</span>
<a name="l00082"></a>00082         <span class="keywordtype">void</span> writeSkeleton(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00083"></a>00083         <span class="keywordtype">void</span> writeBone(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00084"></a>00084         <span class="keywordtype">void</span> writeBoneParent(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> boneId, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> parentId);
<a name="l00085"></a>00085         <span class="keywordtype">void</span> writeAnimation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* anim);
<a name="l00086"></a>00086         <span class="keywordtype">void</span> writeAnimationTrack(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* track);
<a name="l00087"></a>00087         <span class="keywordtype">void</span> writeKeyFrame(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* key);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> writeSkeletonAnimationLink(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, 
<a name="l00089"></a>00089             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>&amp; link);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         <span class="comment">// Internal import methods</span>
<a name="l00092"></a>00092         <span class="keywordtype">void</span> readBone(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00093"></a>00093         <span class="keywordtype">void</span> readBoneParent(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00094"></a>00094         <span class="keywordtype">void</span> readAnimation(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00095"></a>00095         <span class="keywordtype">void</span> readAnimationTrack(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* anim, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00096"></a>00096         <span class="keywordtype">void</span> readKeyFrame(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* track, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00097"></a>00097         <span class="keywordtype">void</span> readSkeletonAnimationLink(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         <span class="keywordtype">size_t</span> calcBoneSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00100"></a>00100         <span class="keywordtype">size_t</span> calcBoneSizeWithoutScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* pBone);
<a name="l00101"></a>00101         <span class="keywordtype">size_t</span> calcBoneParentSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel);
<a name="l00102"></a>00102         <span class="keywordtype">size_t</span> calcAnimationSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* pAnim);
<a name="l00103"></a>00103         <span class="keywordtype">size_t</span> calcAnimationTrackSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>* pTrack);
<a name="l00104"></a>00104         <span class="keywordtype">size_t</span> calcKeyFrameSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* pKey);
<a name="l00105"></a>00105         <span class="keywordtype">size_t</span> calcKeyFrameSizeWithoutScale(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>* pKey);
<a name="l00106"></a>00106         <span class="keywordtype">size_t</span> calcSkeletonAnimationLinkSize(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* pSkel, 
<a name="l00107"></a>00107             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>&amp; link);
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
